/* Transformaciones */

* { box-sizing: border-box; }

html {
  font-family: sans-serif;
  font-size: 16px;
  margin: 0;
  padding: 0;
}

body {
  margin: 40px;
}

.monotype {
  font-family: monospace;
  background-color: khaki;
  padding: 4px 8px;
  border-radius: 4px;
}

.transform-container {
  background-color: grey;
  display: block;
  width: 200px;
  height: 200px;
  margin-bottom: 40px;
  padding: 5px;

  background-color: #f7f7f7;
  border-radius: 3px;
  padding: 20px;

  display: inline-block;
  margin-left: 60px;
}

h2 + .transform-container { margin-left: 0; }

  .transform-item {
    font-size: 20px;
    text-align: center;
    border-radius: 4px;
    background-color: rgba(162, 203, 250, 0.8);
    border: 1px solid #4390E1;
    box-sizing: border-box;
    box-shadow: 0 2px 2px rgba(0,90,250,0.05), 0 4px 4px rgba(0,90,250,0.05), 0 8px 8px rgba(0,90,250,0.05), 0 16px 16px rgba(0,90,250,0.05);
    width: 160px;
    height: 160px;
    position: relative;
    z-index: 10;
  }

  .transform-ghost {
    font-size: 20px;
    text-align: center;
    border-radius: 4px;
    border: 3px dashed #4390E1;
    box-sizing: border-box;
    width: 162px;
    height: 162px;
    position: absolute;
    z-index: 8;
    margin-left: -1px;
    margin-top: -1px;
  }

  .transform-item:after {
      content: '';
      background: #db3951;
      -webkit-transform: scale(0.1);
      transform: scale(0.1);
      display: block;
      width: 100%;
      height: 100%;
      position: absolute;
      top: 0;
      left: 0;
      border: solid 1px #db3951;
      -webkit-transform-origin: inherit;
      transform-origin: inherit;
  }


/* 1. translate() */

.translate-a .transform-item {
  transform: translate(40px, 40px);
}

.translate-b .transform-item {
  transform: translate(-10px, 30px);
}

.translate-c .transform-item {
  transform: translate(-10px, -30px);
}

.translate-d .transform-item {
  transform: translate(60px);
}


/* 2. translateX() */

.translate-x-a .transform-item {
  transform: translateX(40px);
}

.translate-x-b .transform-item {
  transform: translateX(-10px);
}


/* 3. translateY() */

.translate-y-a .transform-item {
  transform: translateY(40px);
}

.translate-y-b .transform-item {
  transform: translateY(-10px);
}


/* 4. translate3d() */

.translate-3d-a .transform-item {
  transform: perspective(100px) translate3d(10px, 20px, 30px);
}

.translate-3d-b .transform-item {
  transform: perspective(100px) translate3d(10px, 20px, 0px);
}


/* 5. rotate() */

.rotate-a .transform-item {
  transform: rotate(45deg);
}

.rotate-b .transform-item {
  transform-origin: left top;
  transform: rotate(20deg);
}

.rotate-c .transform-item {
  transform-origin: 100px 160px;
  transform: rotate(-40deg);
}


/* 6. rotateX() */

.rotate-x-a .transform-item {
  transform: rotateX(40deg);
}

.rotate-x-b .transform-item {
  transform: perspective(450px) rotateX(-40deg);
}


/* 7. rotateY() */

.rotate-y-a .transform-item {
  transform: rotateY(40deg);
}

.rotate-y-b .transform-item {
  transform: perspective(450px) rotateY(-40deg);
}


/* 8. rotateZ() */

.rotate-z-a .transform-item {
  transform: rotateZ(40deg);
}

.rotate-z-b .transform-item {
  transform: perspective(450px) rotateZ(-40deg);
}


/* 9. scale() */

.scale-a .transform-item {
  transform: scale(1.5, 1.25);
}

.scale-b .transform-item {
  transform-origin: left top;
  transform: scale(1.25, 1.25);
}

.scale-c .transform-item {
  transform-origin: 100px 160px;
  transform: scale(1.25, -1.25);
}


/* 10. scaleX() */

.scale-x-a .transform-item {
  transform: scaleX(1.25);
}

.scale-x-b .transform-item {
  transform: scaleX(0.5);
}


/* 11. scaleY() */

.scale-y-a .transform-item {
  transform: scaleY(1.25);
}

.scale-y-b .transform-item {
  transform: scaleY(0.5);
}


/* 12. skew() */

.skew-a .transform-item {
  transform: skew(15deg, 15deg);
}

.skew-b .transform-item {
  transform-origin: left top;
  transform: skew(15deg, 15deg);
}

.skew-c .transform-item {
  transform-origin: 100px 160px;
  transform: skew(15deg, 15deg);
}


/* 10. skewX() */

.skew-x-a .transform-item {
  transform: skewX(15deg);
}

.skew-x-b .transform-item {
  transform: skewX(-15deg);
}


/* 11. skewY() */

.skew-y-a .transform-item {
  transform: skewY(15deg);
}

.skew-y-b .transform-item {
  transform: skewY(-15deg);
}
